<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 30/12/2015
 * Time: 08:39
 */

namespace Util;

use \Zeedhi\DevOps\Util\Events\Audit\Environment as Audit;
use \Zeedhi\DevOps\Util\Events\Organization\Environment as Organization;
use Zeedhi\Framework\ORM\DateTime;
use Zeedhi\Framework\Session\Session;

class PmEnvironment implements Audit, Organization
{

    /** @var Session */
    protected $session;

    public function __construct(Session $session)
    {
        $this->session = $session;
    }

    public function setCurrentUserId($userId)
    {
        $this->session->set("PMUserId", $userId);
    }

    public function getCurrentUserId()
    {
        return $this->session->has("PMUserId") ?$this->session->get("PMUserId"): null;
    }

    public function getUserId()
    {
        return $this->getCurrentUserId();
    }

    public function setOrganizationId($organizationId)
    {
        $this->session->set("ORGANIZATION_ID", $organizationId);
    }

    public function getOrganizationId()
    {
        return $this->session->has("ORGANIZATION_ID")?$this->session->get("ORGANIZATION_ID"): null;
    }

    public function getCurrentOrganizationId()
    {
        return $this->getOrganizationId();
    }

    public function getCurrentTime()
    {
        return new DateTime();
    }

}